package com.rjconsultores.ventaboletos.dao;

import java.util.List;

import com.rjconsultores.ventaboletos.entidad.AliasServico;

public interface AliasServicoDAO extends GenericDAO<AliasServico, Integer>{

	/**
	 * Realiza a buscar com os filtros informados e restringindo o corridaId para is null
	 * 
	 * @param origenId
	 * @param destinoId
	 * @param rutaId
	 * @return
	 */
	public List<AliasServico> buscarAliasSemCorrida(Integer origenId,Integer destinoId,Integer rutaId);
	
	/**
	 * Realiza a busca com os filtro informados.
	 * @param origenId
	 * @param destinoId
	 * @param rutaId
	 * @param corridaId
	 * @return
	 */
	public List<AliasServico> buscar(Integer origenId,Integer destinoId,Integer rutaId,Integer corridaId);
	
}
