/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.dao;

import java.util.Date;
import java.util.List;

import com.rjconsultores.ventaboletos.entidad.ClaseServicio;
import com.rjconsultores.ventaboletos.entidad.Corrida;
import com.rjconsultores.ventaboletos.entidad.Corrida.Id;
import com.rjconsultores.ventaboletos.entidad.DiagramaAutobus;
import com.rjconsultores.ventaboletos.entidad.Marca;
import com.rjconsultores.ventaboletos.entidad.Parada;
import com.rjconsultores.ventaboletos.entidad.Ruta;

/**
 *
 * @author rodrigo
 */
public interface CorridaDAO extends GenericDAO<Corrida, Corrida.Id> {

	/**
	 * Indica si existe una corrida de acuerdo el id
	 * 
	 * No lleva en consideracin el campo activo
	 * 
	 * @param id
	 * @param dataGeracao
	 * @return
	 */
    public Boolean existe(Id id);

    public List<Corrida> buscarPorAutobusCorridasFuturas(DiagramaAutobus diagramaAutobus);

    public List<Corrida> buscarPorRolOperativoCorridasFuturas(DiagramaAutobus diagramaAutobus);

    public List<Corrida> buscarPorFecCorrida(Date value);

    public Long count(Ruta ruta);

    public List<Corrida> buscarPorId(Integer idCorrida);

    public List<Corrida> buscarFiltro(Parada ori, Parada des, Date hora, ClaseServicio cs);

    /**
     * Hace la b�squeda de corridas con distinct para: origen, destino, claseServicio,hora
     * 
     * @param ori
     * @param des
     * @param horaSalidaInicio
     * @param horaSalidaFin
     * @param cs
     * @param corridaId
     * @return
     */
    public List<Corrida> buscarDistinct(Parada ori, Parada des, Date horaSalidaInicio, Date horaSalidaFin, ClaseServicio cs, Integer corridaId);

    public boolean existe(Ruta ruta, Date dataGeracao, Date horario, ClaseServicio claseServicio, Marca marca, boolean pisoExtra);

    public boolean count(Parada origem, Parada destino, Date feccorrida, ClaseServicio claseServicio, boolean pisoExtra);
    
    
    /**
     * Regresa la cantidad de corridas que fue generada hoy.
     * 
     * @return
     */
    public Long cantCorridaGeneradasHoy();
}