package com.rjconsultores.ventaboletos.dao.hibernate;

import java.util.List;

import org.hibernate.Criteria;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

import com.rjconsultores.ventaboletos.dao.AliasServicoDAO;
import com.rjconsultores.ventaboletos.entidad.AliasServico;

@Repository("aliasServicoDAO")
public class AliasServicoHibernateDAO extends GenericHibernateDAO<AliasServico, Integer>
		implements AliasServicoDAO {

	@Autowired
	public AliasServicoHibernateDAO(@Qualifier("sessionFactory") SessionFactory factory) {
		setSessionFactory(factory);
	}

	@Override
	public List<AliasServico> buscarAliasSemCorrida(Integer origenId, Integer destinoId, Integer rutaId) {

		Criteria c = makeCriteria();
		c.add(Restrictions.eq("activo", Boolean.TRUE));
		c.add(Restrictions.eq("origen.paradaId",origenId));
		c.add(Restrictions.eq("destino.paradaId",destinoId));
		c.add(Restrictions.eq("ruta.rutaId",rutaId));
		c.add(Restrictions.isNull("corridaId"));
		
		return c.list();
	}

	@Override
	public List<AliasServico> buscar(Integer origenId, Integer destinoId, Integer rutaId, Integer corridaId) {
		Criteria c = makeCriteria();
		c.add(Restrictions.eq("activo", Boolean.TRUE));
		c.add(Restrictions.eq("origen.paradaId",origenId));
		c.add(Restrictions.eq("destino.paradaId",destinoId));
		c.add(Restrictions.eq("ruta.rutaId",rutaId));
		c.add(Restrictions.eq("corridaId",corridaId));
		
		return c.list();
	}
}
